// Generated by CoffeeScript 1.8.0
var execute, krb5_ktadd, misc, wrap;

module.exports = function(goptions, options, callback) {
  return wrap(arguments, function(options, next) {
    var do_end, do_kadmin, do_keytab, modified;
    if (!options.principal) {
      return next(new Error('Property principal is required'));
    }
    if (!options.password && !options.randkey) {
      return next(new Error('Password or randkey missing'));
    }
    modified = false;
    do_kadmin = function() {
      var cmd;
      if (/.*@.*/.test(options.kadmin_principal)) {
        if (options.realm == null) {
          options.realm = options.kadmin_principal.split('@')[1];
        }
      }
      cmd = misc.kadmin(options, options.password ? "addprinc -pw " + options.password + " " + options.principal : "addprinc -randkey " + options.principal);
      return execute({
        cmd: cmd,
        ssh: options.ssh,
        log: options.log,
        stdout: options.stdout,
        stderr: options.stderr
      }, function(err, _, stdout) {
        if (err) {
          return next(err);
        }
        if (-1 === stdout.indexOf('already exists')) {
          modified = true;
        }
        return do_keytab();
      });
    };
    do_keytab = function() {
      return krb5_ktadd(options, function(err, ktadded) {
        if (ktadded) {
          modified = true;
        }
        return do_end();
      });
    };
    do_end = function() {
      return next(null, modified);
    };
    return do_kadmin();
  });
};

misc = require('./misc');

wrap = require('./misc/wrap');

execute = require('./execute');

krb5_ktadd = require('./krb5_ktadd');
