// Generated by CoffeeScript 1.8.0
var each, exec, fs, misc;

each = require('each');

misc = require('./index');

exec = require('ssh2-exec');

fs = require('ssh2-fs');

module.exports = {
  "if": function(options, skip, succeed) {
    var ok;
    if (options["if"] == null) {
      return succeed();
    }
    ok = true;
    return each(options["if"]).on('item', function(si, next) {
      var type;
      if (!ok) {
        return next();
      }
      type = typeof si;
      if (type === 'boolean' || type === 'number') {
        if (!si) {
          ok = false;
        }
        return next();
      } else if (type === 'function') {
        if (options["if"].length === 1) {
          return si(function(err, is_ok) {
            if (err) {
              return next(err);
            }
            if (!is_ok) {
              ok = false;
            }
            return next();
          });
        } else if (options["if"].length === 2) {
          return si(options, function(err, is_ok) {
            if (err) {
              return next(err);
            }
            if (!is_ok) {
              ok = false;
            }
            return next();
          });
        } else if (options["if"].length === 3) {
          return si(options, (function() {
            ok = false;
            return next.apply(null, arguments);
          }), next);
        } else {
          return next(new Error("Invalid callback"));
        }
      } else {
        return next(new Error("Invalid condition type"));
      }
    }).on('both', function(err) {
      if (err || !ok) {
        return skip(err);
      }
      return succeed();
    });
  },
  not_if: function(options, skip, succeed) {
    var ok;
    if (options.not_if == null) {
      return succeed();
    }
    ok = true;
    return each(options.not_if).on('item', function(not_if, next) {
      var type;
      if (!ok) {
        return next();
      }
      type = typeof not_if;
      if (type === 'boolean' || type === 'number') {
        if (not_if) {
          ok = false;
        }
        return next();
      } else if (type === 'function') {
        if (options.not_if.length === 1) {
          return not_if(function(err, is_ok) {
            if (err) {
              return next(err);
            }
            if (is_ok) {
              ok = false;
            }
            return next();
          });
        } else if (options.not_if.length === 2) {
          return not_if(options, function(err, is_ok) {
            if (err) {
              return next(err);
            }
            if (is_ok) {
              ok = false;
            }
            return next();
          });
        } else if (options.not_if.length === 3) {
          return not_if(options, next, (function() {
            ok = false;
            return next.apply(null, arguments);
          }));
        } else {
          return next(new Error("Invalid callback"));
        }
      } else {
        return next(new Error("Invalid condition type"));
      }
    }).on('both', function(err) {
      if (err || !ok) {
        return skip(err);
      }
      return succeed();
    });
  },
  if_exec: function(options, skip, succeed) {
    if (options.if_exec == null) {
      return succeed();
    }
    return each(options.if_exec).on('item', function(cmd, next) {
      var run;
      if (typeof options.log === "function") {
        options.log("Mecano `if_exec`: " + cmd);
      }
      options = {
        cmd: cmd,
        ssh: options.ssh
      };
      run = exec(options);
      if (options.stdout) {
        run.stdout.pipe(options.stdout, {
          end: false
        });
      }
      if (options.stderr) {
        run.stderr.pipe(options.stderr, {
          end: false
        });
      }
      return run.on("exit", function(code) {
        if (typeof options.log === "function") {
          options.log("Mecano `if_exec`: code is \"" + code + "\"");
        }
        if (code === 0) {
          return next();
        } else {
          return skip();
        }
      });
    }).on('end', succeed);
  },
  not_if_exec: function(options, skip, succeed) {
    if (options.not_if_exec == null) {
      return succeed();
    }
    return each(options.not_if_exec).on('item', function(cmd, next) {
      var run;
      if (typeof options.log === "function") {
        options.log("Mecano `not_if_exec`: " + cmd);
      }
      options = {
        cmd: cmd,
        ssh: options.ssh
      };
      run = exec(options);
      if (options.stdout) {
        run.stdout.pipe(options.stdout, {
          end: false
        });
      }
      if (options.stderr) {
        run.stderr.pipe(options.stderr, {
          end: false
        });
      }
      return run.on("exit", function(code) {
        if (typeof options.log === "function") {
          options.log("Mecano `not_if_exec`: code is \"" + code + "\"");
        }
        if (code === 0) {
          return next(new Error);
        } else {
          return next();
        }
      });
    }).on('error', function() {
      return skip();
    }).on('end', succeed);
  },
  if_exists: function(options, skip, succeed) {
    var destination, if_exists, ssh;
    ssh = options.ssh, if_exists = options.if_exists, destination = options.destination;
    if (typeof not_if_exists === 'boolean' && destination) {
      if_exists = if_exists ? [destination] : null;
    }
    if (if_exists == null) {
      return succeed();
    }
    return each(if_exists).on('item', function(if_exists, next) {
      return fs.exists(ssh, if_exists, function(err, exists) {
        if (exists) {
          return next();
        } else {
          return skip();
        }
      });
    }).on('end', succeed);
  },
  not_if_exists: function(options, skip, succeed) {
    var destination, not_if_exists, ssh;
    ssh = options.ssh, not_if_exists = options.not_if_exists, destination = options.destination;
    if (typeof not_if_exists === 'boolean' && destination) {
      not_if_exists = not_if_exists ? [destination] : null;
    }
    if (not_if_exists == null) {
      return succeed();
    }
    return each(not_if_exists).on('item', function(not_if_exists, next) {
      return fs.exists(ssh, not_if_exists, function(err, exists) {
        if (exists) {
          return next(new Error);
        } else {
          return next();
        }
      });
    }).on('error', function() {
      return skip();
    }).on('end', succeed);
  },
  should_exist: function(options, skip, succeed) {
    if (options.should_exist == null) {
      return succeed();
    }
    return each(options.should_exist).on('item', function(should_exist, next) {
      return fs.exists(options.ssh, should_exist, function(err, exists) {
        if (exists) {
          return next();
        } else {
          return next(Error("File does not exist: " + should_exist));
        }
      });
    }).on('error', function(err) {
      return skip(err);
    }).on('end', succeed);
  },
  should_not_exist: function(options, skip, succeed) {
    if (options.should_not_exist == null) {
      return succeed();
    }
    return each(options.should_not_exist).on('item', function(should_not_exist, next) {
      return fs.exists(options.ssh, should_not_exist, function(err, exists) {
        if (exists) {
          return next(new Error("File does not exist: " + should_not_exist));
        } else {
          return next();
        }
      });
    }).on('error', function(err) {
      return skip(err);
    }).on('end', function() {
      return succeed();
    });
  },
  all: function(options, failed, succeed) {
    var conditions, i, next;
    conditions = ['if', 'not_if', 'if_exec', 'not_if_exec', 'if_exists', 'not_if_exists', 'should_exist'];
    i = 0;
    next = function() {
      var condition;
      condition = conditions[i++];
      if (!condition) {
        return succeed();
      }
      return module.exports[condition](options, (function(err) {
        if (typeof options.log === "function") {
          options.log("Mecano `" + condition + "`: failed");
        }
        return failed(err);
      }), (function() {
        if (typeof options.log === "function") {
          options.log("Mecano `" + condition + "`: succeed");
        }
        return next();
      }));
    };
    return next();
  }
};
