// Generated by CoffeeScript 1.8.0
var fs, path, wrap, write;

module.exports = function(goptions, options, callback) {
  return wrap(arguments, function(options, next) {
    var do_read_source, do_write;
    if (!(options.source || options.content)) {
      return next(new Error('Missing source or content'));
    }
    if (!options.destination) {
      return next(new Error('Missing destination'));
    }
    do_read_source = function() {
      var ssh;
      if (!options.source) {
        return do_write();
      }
      ssh = options.local_source ? null : options.ssh;
      return fs.exists(ssh, options.source, function(err, exists) {
        if (!exists) {
          return next(new Error("Invalid source, got " + (JSON.stringify(options.source))));
        }
        return fs.readFile(ssh, options.source, 'utf8', function(err, content) {
          if (err) {
            return next(err);
          }
          options.content = content;
          return do_write();
        });
      });
    };
    do_write = function() {
      var extension;
      if (!options.engine && options.source) {
        extension = path.extname(options.source);
        if (extension === '.j2') {
          options.engine = 'nunjunks';
        }
      }
      options.source = null;
      return write(options, function(err, written) {
        return next(err, written);
      });
    };
    return do_read_source();
  });
};

fs = require('ssh2-fs');

path = require('path');

wrap = require('./misc/wrap');

write = require('./write');
